## jppy 0.0.45

=== SConstruct ===
--- 
+++ 
@@ -18,9 +18,12 @@
 
 opts = Options('SCustomize')
 
-opts.Add(('python_version','Python library version to use','libpython2.4.so'))
-opts.Add(PathOption('python_module_prefix','Prefix to install python module and extension to',
-                    os.path.join(distutils.sysconfig.get_python_lib(),'jppy'),PathOption.PathAccept))
+default_module_prefix = os.path.join(distutils.sysconfig.get_python_lib(),'jppy')
+
+opts.Add(PathOption('python_module_prefix','Prefix to install python module to',
+                    default_module_prefix,PathOption.PathAccept))
+opts.Add(PathOption('python_bin_module_prefix','Prefix to install python binary module to',
+                    default_module_prefix,PathOption.PathAccept))
 opts.Add(PathOption('prefix','Prefix to install /bin/<scripts> to',
                     '/usr/local'))
 opts.Add(PathOption('mx_datetime_includes','Path to mx/mxDateTime.h',
@@ -38,17 +41,20 @@
 opts.Add(PackageOption('rpathoverride','Link with an rpath','no'))
 opts.Add(BoolOption('test','Do you want to run the tests?','yes'))
 opts.Add(BoolOption('profile','Do you want compile with profiling?','no'))
+opts.Add('python_version','Python library version', sys.version[0:3])
 
 env = Environment(options=opts,
-                  CCFLAGS=['-g',
-                           '-DPYTHON_SHARED_LIB=\\"${python_version}\\"'],
-                  LINKFLAGS=['-L$pisock_library'],
-#                             distutils.sysconfig.get_config_var('LINKFORSHARED')],
-#                             '-lpython%s' % sys.version[0:3]],
+                  CCFLAGS=['-g'],
                   CPPPATH=['${mx_datetime_includes}',
                            '${pisock_includes}',
                            '${python_includes}',
                            '#/libversit_src'])
+
+if env['python_module_prefix'] != default_module_prefix and \
+   env['python_bin_module_prefix'] == default_module_prefix:
+     print "Making python_bin_module_prefix match your non-default python_module_prefix"
+     env['python_bin_module_prefix'] = env['python_module_prefix']
+
 if env['profile']:
      env.Append(CCFLAGS='-pg')
      env.Append(LINKFLAGS='-pg')
@@ -95,7 +101,10 @@
 
 if not config.CheckPKG('pygtk-2.0 >= 2.4.0'): 
      print 'pygtk-2.0 >= 2.4.0 not found.' 
-     Exit(1)     
+     Exit(1)
+
+env.ParseConfig('pkg-config --cflags --libs glib-2.0')
+env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
      
 #standard stuff
 for hdr in [['Python.h','mx/mxDateTime.h']]:
@@ -103,20 +112,6 @@
           print "You need '%s' to compile this program" % hdr
           Exit(1)
           
-if not config.CheckLibWithHeader('libpisock',
-                                 'pi-socket.h','C','pi_socket_connected(0);'):
-     print "You need libpisock to compile this program"
-     Exit(1)
-
-if not config.CheckLibWithHeader('libpython%s' % sys.version[0:3],
-                                 'Python.h','C','PyErr_Clear();'):
-     print "You need libpython%s.so to compile this program" % sys.version[0:3]
-     Exit(1)
-     
-env.ParseConfig('pkg-config --cflags --libs gtk+-2.0')
-env.ParseConfig('pkg-config --cflags --libs glib-2.0')
-env.ParseConfig('pkg-config --cflags --libs pygtk-2.0') 
-
 vars = distutils.sysconfig.get_config_vars('CC', 'CXX', 'OPT', 'BASECFLAGS',
                                            'CCSHARED', 'LDSHARED', 'SO') 
 for i in range(len(vars)): 
@@ -144,6 +139,8 @@
 
 env['python_module_path'] = os.path.join(env['jppyroot'],
                                          env['python_module_prefix'][1:])
+env['python_bin_module_path'] = os.path.join(env['jppyroot'],
+                                         env['python_bin_module_prefix'][1:])
 env['python_gui_module_path'] = os.path.join(env['jppyguiroot'],
                                              env['python_module_prefix'][1:])
 env['jpilot_plugin_prefix'] = os.path.join(env['prefix'],
@@ -152,40 +149,74 @@
                                          env['jpilot_plugin_prefix'][1:])
 
 ######### Jpilot
+jpilotEnv = env.Clone()
+jpilotConfig = jpilotEnv.Configure()
+if not jpilotConfig.CheckLibWithHeader('libpisock',
+                                       'pi-socket.h','C','pi_socket_connected(0);'):
+     print "You need libpisock to compile this program"
+     Exit(1)
+jpilotConfig.Finish()
 jpilot_sources = ['log', 'libplugin', 'utils', 'prefs',
                   'plugins', 'sync', 'japanese', 'cp1250',
                   'russian', 'password', 'category', 'otherconv']
 # a bit of a hack. Scons doesn't support shared objects in static libraries.
-libjpilot = env.StaticLibrary(target='jpilot_src/jppy_jpilot',
-                              source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
-                              CCFLAGS="$CCFLAGS -fPIC")
+libjpilot = jpilotEnv.StaticLibrary(target='jpilot_src/jppy_jpilot',
+                                    source = ["jpilot_src/%s.c" % x for x in jpilot_sources],
+                                    CCFLAGS="$CCFLAGS -fPIC")
 libjpilot[0].attributes.shared = True
 
 
 ######### Jppy
-jppymodule = env.SharedLibrary(target = 'jppy/__jpilotmodule',
-                               source = ['python_module_src/jpilot.i',
-                                         'python_module_src/move_into_libpisock.c',
-                                         'python_module_src/jpilot_helpers.c',
-                                         libjpilot] +
-                               glob.glob("python_module_src/pytype*.c") +
-                               ["libversit_src/%s" % x for x in ["vcc.y",
-                                                                 "vobject.c",
-                                                                 "vcaltmp.c"]],
-                               SHLIBPREFIX="",
-                               SHLIBSUFFIX=pyso_ext,
-                               SWIGFLAGS="-python -outdir ./jppy/")
+jppyEnv = jpilotEnv.Clone()
+jppyEnv.ParseConfig('pkg-config --cflags --libs pygtk-2.0')      
+jppymodule = jppyEnv.SharedLibrary(target = 'jppy/__jpilotmodule',
+                                   source = ['python_module_src/jpilot.i',
+                                             'python_module_src/move_into_libpisock.c',
+                                             'python_module_src/jpilot_helpers.c',
+                                             libjpilot] +
+                                   glob.glob("python_module_src/pytype*.c") +
+                                   ["libversit_src/%s" % x for x in ["vcc.y",
+                                                                     "vobject.c",
+                                                                     "vcaltmp.c"]],
+                                   SHLIBPREFIX="",
+                                   SHLIBSUFFIX=pyso_ext,
+                                   SWIGFLAGS="-python -outdir ./jppy/")
 
 ######### Jpilot Plugins
-pluginEnv = env.Copy(SHLIBSUFFIX=pyso_ext,
-                     SHLIBPREFIX="lib")
+
+pluginEnv = env.Clone(SHLIBSUFFIX=pyso_ext,
+                      SHLIBPREFIX="lib")
 pluginEnv.Append(CPPPATH=['#/jpilot_src'])
-pluginEnv.Append(CPPDEFINES='JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"')
+
+pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
+
+jppyPluginEnv = pluginEnv.Clone()
+jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"libpython${python_version}.so\\"'])
+jppyPluginConfig = jppyPluginEnv.Configure()
+if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
+                                           'Python.h','C','PyErr_Clear();'): 
+     print "You need libpython%s.so to compile this program" % env['python_version']
+     Exit(1) 
+jppyPluginConfig.Finish()
+jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
+
 jpilot_plugins = []
-for source in glob.glob('jpilot_plugins/*.c'):
-     jpilot_plugins.append(pluginEnv.SharedLibrary(
-          target = os.path.splitext(source)[0],
-          source = source))
+
+jpilot_plugins.append(jppyPluginEnv.SharedLibrary(target = "jpilot_plugins/jppy",
+                                                  source = "jpilot_plugins/jppy.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-Contacts",
+                                              source = "jpilot_plugins/sync-Contacts.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogA",
+                                              source = "jpilot_plugins/sync-PTimLogA.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogB",
+                                              source = "jpilot_plugins/sync-PTimLogB.c"))
+
+jpilot_plugins.append(pluginEnv.SharedLibrary(target = "jpilot_plugins/sync-PTimLogC",
+                                              source = "jpilot_plugins/sync-PTimLogC.c"))
+
 jpilot_plugins.append(File('#jpilot_plugins/jpilot_site.py'))
      
 
@@ -239,8 +270,8 @@
 env['INSTALL'] = copyFunc
 
 env.Alias('install', Dir(env['python_module_path']))
-env.Install(env['python_module_path'], [jppymodule +
-                                        glob.glob("jppy/*py")])
+env.Install(env['python_module_path'], glob.glob("jppy/*py"))
+env.Install(env['python_bin_module_path'], jppymodule)
 
 env.Install(os.path.join(env['python_gui_module_path'],"gui"),
             [glob.glob("jppy/gui/*.py") +
