## jppy 0.0.47

=== SConstruct ===
--- 
+++ 
@@ -10,6 +10,7 @@
 from helpers import *
 import dbhash
 import SCons
+import commands
 
 print """Please remember that SCons does NOT automatically use your shell
 environment variables. This script uses PKG_CONFIG_PATH explicitly."""
@@ -190,15 +191,17 @@
 
 pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
 
+
 jppyPluginEnv = pluginEnv.Clone()
-jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"libpython${python_version}.so\\"'])
+jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
 jppyPluginConfig = jppyPluginEnv.Configure()
 if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
                                            'Python.h','C','PyErr_Clear();'): 
      print "You need libpython%s.so to compile this program" % env['python_version']
      Exit(1) 
 jppyPluginConfig.Finish()
-jppyPluginEnv.Append(LINKFLAGS=distutils.sysconfig.get_config_var('LINKFORSHARED'))
+python_library_filename = commands.getoutput("./find-python-library-name.sh libpython%s.so" % env['python_version'])
+jppyPluginEnv.Append(CPPDEFINES=['PYTHON_SHARED_LIB=\\"%s\\"' % python_library_filename])
 
 jpilot_plugins = []
