## jppy 0.0.59-1

=== SConstruct ===
--- 
+++ 
@@ -59,7 +59,7 @@
                   tools = ["default", "doxygen"],
                   toolpath='.',
                   ENV = {'PATH' : os.environ['PATH'],
-                         'HOME' : os.environ['HOME'],
+                         'HOME' : os.environ.get('HOME',''),
                          'TERM' : os.environ.get('TERM',''),}
                   )
 
@@ -245,7 +245,7 @@
      pluginEnv.Append(CPPDEFINES=['JPILOT_PLUGIN_PREFIX=\\"$jpilot_plugin_prefix\\"'])
 
      jppyPluginEnv = pluginEnv.Clone()
-     linkflags=distutils.sysconfig.get_config_var('LINKFORSHARED')
+     linkflags=distutils.sysconfig.get_config_var('LINKFORSHARED').split()
      jppyPluginEnv.Append(LINKFLAGS=[linkflags])
      jppyPluginConfig = jppyPluginEnv.Configure()
      if not jppyPluginConfig.CheckLibWithHeader("libpython%s" % env['python_version'], 
@@ -290,4 +290,3 @@
                    outf.write("#!%s%s\n" % 
                               (os.path.normpath(sys.executable),
                                post_interp))
-              else:
