=== debian/changelog ===
jppy (0.0.59-1) unstable; urgency=low

  * New upstream release
  * Bug fix: "FTBFS if HOME is unset: KeyError: &#39;HOME&#39;", thanks to
    Jakub Wilk (Closes: #626800).

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sat, 25 Jun 2011 09:49:39 +0100

jppy (0.0.58-1) unstable; urgency=low

  * New upstream release

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 15 May 2011 00:55:05 +0100

jppy (0.0.57-1) unstable; urgency=low

  * Fix building with Debian unstable (Closes: #626421).

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sat, 14 May 2011 23:48:01 +0100

jppy (0.0.56-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Bug fix, the plugin should be compiled against the current debian python
    version. (Closes: #586930) Applying patch proposed by:
    Jakub Wilk <jwilk@debian.org>

 -- Maximiliano Curia <maxy@debian.org>  Tue, 03 Aug 2010 20:37:23 -0400

jppy (0.0.56-1) unstable; urgency=low

  [ Nicholas C Piper ]
  * Bug fix: "FTBFS on ia64: segmentation fault (unaligned access?)",
    thanks to Jakub Wilk (Closes: #574741).

  [ Norbert Preining ]
  * debian/control lintian warning fixes:
    - add misc:Depends deps to jppy-doc, jppy, jppy-lbdb-module
    - bump standards version to 3.9.0, no changes necessary

 -- Norbert Preining <preining@debian.org>  Thu, 01 Jul 2010 15:49:20 +0900

jppy (0.0.55-1) unstable; urgency=low

  * Upstream made compatible with pilot-link 0.12.5 (Closes:  #569363)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 21 Feb 2010 22:26:04 +0000

jppy (0.0.54-3) unstable; urgency=low

  * Bug fix: "FTBFS: scons: *** Path for option pisock_library does not
    exist: /usr/lib64" (Closes: #558670)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Sun, 21 Feb 2010 19:45:37 +0000

jppy (0.0.54-2) unstable; urgency=low

  * Fix "jppy 0.0.54-1 should depend on python-mysqldb, in order to make
    jppy work". Added to depends for python-jppy (Closes: #565425)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 25 Jan 2010 19:53:50 +0000

jppy (0.0.54-1) unstable; urgency=low

  * Bug fix in upstream: "jppy - FTBFS: KeyError: 'TERM'" (Closes: #554088)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Wed, 04 Nov 2009 22:41:50 +0000

jppy (0.0.53-1) unstable; urgency=low

  * Correction to version number

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 26 Oct 2009 20:53:35 +0000

jppy (0.0.52-1) unstable; urgency=low

  * Change jppy homepage in control file to current URL (Closes: #515171).
  * Corrections to how we use python-support (Closes: #516304).
  * Upstream has moved glade files into /usr/share/jppy
  * Bug fix: "should depend on python-gtkspell instead on
    python-gnome2-extras", thanks to Josselin Mouette (Closes: #541594).
  * Upstream now supports pilot-link 0.12.4 (Closes: #533944, #537244).
  * Drop Python2.4 support since pygobject did in 2.15.4-1

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Mon, 26 Oct 2009 20:13:55 +0000

jppy (0.0.48-1) experimental; urgency=low

  * New upstream release
  * Change VCS location to new git repository
  * Acknowledge NMU, thanks. (Closes: #496748)

 -- Nicholas C Piper <nick-debian@nickpiper.co.uk>  Wed, 08 Oct 2008 17:57:42 +0100

jppy (0.0.47-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Moved python-vobject, jpilot from Recommends: to Depends: (Closes: 496748)

 -- Mike O'Connor <stew@debian.org>  Sat, 04 Oct 2008 21:16:11 -0400

jppy (0.0.47-1) unstable; urgency=low

  * New upstream release (closes: #491848, #493082).

 -- martin f. krafft <madduck@debian.org>  Tue, 26 Aug 2008 13:12:23 +0100

jppy (0.0.45-1) unstable; urgency=low

  * New upstream version, which now builds for all supported Python versions
    and installs arch-dependent stuff to /usr/lib (closes: #488317). Thanks to
    Nick Piper, who did all the work!
  * Change maintainer to the new jppy-devel mailing list.

 -- martin f. krafft <madduck@debian.org>  Sat, 28 Jun 2008 12:48:24 +0200

jppy (0.0.44-2) unstable; urgency=low

  * Do not limit ourselves to a single Python version (closes: #488307).
  * Fix migration from python-central to python-support and clean up after
    python-central (see #479852).

 -- martin f. krafft <madduck@debian.org>  Fri, 27 Jun 2008 20:45:02 +0200

jppy (0.0.44-1) unstable; urgency=low

  * New upstream release (closes: #445379, #476679).
  * Completely redo the Debian packaging:
    - rewrite debian/rules
    - use python-support to build for the current Python version.
    - jppy recommends jpilot to make the stock PDB files available.
    - bump Standards-Version to 3.8.0; no changes needed.
    - update Vcs-* headers to point to git.debian.org.
    - add Homepage field.
    - depend on python-tz, which python-jppy now uses.
    - add build-dependencies on python-tz, python-pisock, python-reportlab,
      and python-vobject.
    - move menu entry from Apps/Tools to Applications/Data Management as per
      the Debian menu sub-policy.

 -- martin f. krafft <madduck@debian.org>  Fri, 02 May 2008 00:26:50 +0100

jppy (0.0.43-1) unstable; urgency=low

  * New upstream release.
  * First release to Debian unstable.
  * Updated the copyright file to include all licences used by jppy.

 -- martin f. krafft <madduck@debian.org>  Wed, 04 Jul 2007 20:25:35 +0200

jppy (0.0.41-1) unstable; urgency=low

  * New upstream release, which adds jp_*lookup scripts and fixes a problem
    with the lbdb module's use of exec.

 -- martin f. krafft <madduck@debian.org>  Thu, 24 May 2007 17:04:01 +0200

jppy (0.0.40-1) unstable; urgency=low

  * Resynchronised with head revision.
  * Only build against current python version, not all of them.
  * New package: jppy-lbdb-module, which allows lbdb to query the jppy
    Contacts-PAdd database.

 -- martin f. krafft <madduck@debian.org>  Thu, 24 May 2007 17:03:54 +0200

jppy (0.0.39+svn+r224-1~unreleased.2) UNRELEASED; urgency=low

  * Make jppy depend on python-vobject.


