## jppy 0.0.59-1build1

=== debian/changelog ===
jppy (0.0.59-1build1) precise; urgency=low

  * Rebuild to drop python2.6 dependencies and provides.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 14 Apr 2012 13:42:46 +0000
