=== debian/control ===
Source: jppy
Section: python
Priority: optional
Maintainer: jppy development team <jppy-devel@zanu.org.uk>
Uploaders: Nicholas C Piper <nick-debian@nickpiper.co.uk>, Norbert Preining <preining@debian.org>, martin f. krafft <madduck@debian.org>
Standards-Version: 3.9.0
Build-Depends: debhelper (>= 7), scons, swig, libgtk2.0-dev, python-gtk2-dev, bison, libpisock-dev (>= 0.12.5), python-egenix-mx-base-dev, python-egenix-mxdatetime, python-dev, python-glade2, python-gtkspell, python-gnome2, python-all-dev, python-support (>= 0.5.3), python-dateutil, python-tz, python-pisock (>= 0.12.2-11), python-vobject, python-reportlab, python-mysqldb, python-pyparsing, python-imaging
Vcs-Git: git://git.debian.org/git/jppy/jppy.git
Vcs-Browser: http://git.debian.org/?p=jppy/jppy.git
Homepage: http://jppy.alioth.debian.org/
XS-Python-Version: >= 2.5

Package: python-jppy
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-reportlab, python-egenix-mxdatetime, python-pisock (>= 0.12.4-3), python-gtk2, python-gtkspell, python-pyparsing, python-glade2, python-gnome2, python-dateutil, python-tz, python-imaging, python-mysqldb
Provides: ${python:Provides}
Replaces: jppy (<< 0.0.38)
Description: Python API to access J-Pilot contacts, memo, and task databases
 This package provides a Python API for accessing the J-Pilot contacts, memo,
 and task databases.

Package: jppy
Section: x11
Architecture: all
Depends: python-jppy (>= ${binary:Version}), ${python:Depends}, python-vobject, jpilot, ${misc:Depends}
Recommends: txt2pdbdoc
Suggests: mutt, jppy-jpilot-plugins
Description: Personal Information Manager using J-Pilot/Palm PDA databases
 jppy is a GUI for manipulating J-Pilot contacts, tasks and memo databases. As
 opposed to the jpilot package, it provides access to the extended fields of
 newer PalmOS contact databases (PalmOS 5 and up).

Package: jppy-doc
Section: doc
Architecture: all
Suggests: jppy
Depends: ${misc:Depends}
Description: Documentation for jppy
 This package installs the documentation for jppy.

Package: jppy-jpilot-plugins
Section: otherosfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jppy (= ${source:Version})
Recommends: jpilot
Description: J-Pilot plugins to integrate jppy
 This package installs plugins that integrate jppy with J-Pilot and handles
 synchronisation of the extended contacts database used by newer PalmOS
 (version 5 and up).

Package: jppy-lbdb-module
Section: mail
Architecture: all
Depends: python-jppy (>= ${binary:Version}), ${python:Depends}, ${misc:Depends}
Recommends: lbdb
Description: lbdb module to interface with jppy
 This package provides m_palm_db6, a module to let lbdb query the
 Contacts-PAdd database used by jppy.
